DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Private Member Functions | Private Attributes | List of all members
EctEnhancedCT Class Reference

Class representing an object of the "Enhanced CT SOP Class". More...

Inheritance diagram for EctEnhancedCT:

## Classes
class | Frames
| Inner class that offers typed interface to bulk data. More...

## Public Types
typedef OFvariant< OFCondition, Frames< Uint16 >, Frames< Sint16 > > | FramesType
| Frames can contain Uint16, Sint16 or nothing (i.e. error condition) at all (in that case OFCondition denotes a corresponding error)
Public Types inherited from DcmIODImage< IODImagePixelModule< Uint16 >, IODImagePixelModule< Sint16 > >
typedef DcmIODImage | IODImage
| typedef for old compilers that do not define the type 'DcmIODImage' in derived classes.
typedef IODImagePixelVariant< OFVARIADIC_TEMPLATE_PARAMETER_PACK(T)> | IODImagePixelModuleType
| A good comment would be nice, but I have nothing in mind.

## Public Member Functions
virtual | ~EctEnhancedCT ()
| Destructor, frees memory.
OFCondition | saveFile (const OFString &filename, const E_TransferSyntax writeXfer=EXS_LittleEndianExplicit)
| Save current object to given filename. More...
OFCondition | writeDataset (DcmItem &dataset)
| Write current object to given item. More...
OFCondition | writeConcatenation (ConcatenationCreator &cc)
| Write current object to a Concatenation. More...
virtual void | setCheckFGOnWrite (const OFBool doCheck)
| If enabled, functional group structure is checked before actual writing is performed in the write() method. More...
virtual OFBool | getCheckFGOnWrite ()
| Returns whether functional group structure is checked before actual writing is performed in the write() method. More...
virtual void | setValueCheckOnWrite (const OFBool doCheck)
| Set whether attribute values should be checked on writing, i.e. More...
size_t | getNumberOfFrames () const
| Get number of frames, based on the number of items in the shared functional functional groups sequence (i.e. the attribute Number of Frames) is not trusted). More...
virtual OFBool | check (const OFBool checkFGStructure=OFTrue)
| Perform some basic checking. More...
virtual FGInterface & | getFunctionalGroups ()
| Get access to functional groups. More...
virtual IODMultiFrameFGModule::ConcatenationInfo & | getConcatenationInfo ()
| Get reference t Concatenation information. More...
virtual OFCondition | addForAllFrames (const FGBase &group)
| Add a functional group for all frames. More...
virtual IODMultiframeDimensionModule & | getDimensions ()
| Return reference to multi-fame dimension module. More...
virtual FramesType | getFrames ()
| Return Frames. More...
virtual OFCondition | importFromSourceImage (DcmItem &dataset, const OFBool takeOverCharset=OFTrue)
| Import Patient, Study, and Frame of Reference level information from the given item. More...
virtual OFCondition | importFromSourceImage (const OFString &filename, const OFBool takeOverCharset=OFTrue)
| Import Patient, Study, and Frame of Reference level information from the given item. More...
virtual IODPatientModule & | getIODPatientModule ()
| Get Patient Module. More...
virtual IODGeneralStudyModule & | getIODGeneralStudyModule ()
| Get General Study Module. More...
virtual IODPatientStudyModule & | getIODPatientStudyModule ()
| Get Patient Study Module. More...
virtual IODGeneralSeriesModule & | getIODGeneralSeriesModule ()
| Get General Series Module. More...
virtual IODFoRModule & | getIODFrameOfReferenceModule ()
| Get Frame of Reference Module. More...
virtual IODSynchronizationModule & | getIODSynchronizationModule ()
| Get Synchronization Module. More...
virtual void | setIODSynchronizationModuleEnabled (const OFBool enabled)
| Set whether Synchronization Module will be enabled when writing the Enhanced CT object. More...
virtual OFBool | getIODSynchronizationModuleEnabled ()
| Returns whether Synchronization Module is enabled for writing the Enhanced CT object. More...
virtual IODGeneralEquipmentModule & | getIODGeneralEquipmentModule ()
| Get General Equipment Module. More...
virtual IODEnhGeneralEquipmentModule & | getIODEnhGeneralEquipmentModule ()
| Get Enhanced General Equipment Module. More...
virtual IODMultiFrameFGModule & | getIODMultiFrameFGModule ()
| Get Multi-frame Functional Groups Module. More...
virtual IODMultiframeDimensionModule & | getIODMultiframeDimensionModule ()
| Get Multi-frame Dimension Module. More...
virtual IODAcquisitionContextModule & | getIODAcquisitionContextModule ()
| Get Acquisition Context Module. More...
virtual IODCommonInstanceReferenceModule & | getIODCommonInstanceReferenceModule ()
| Get Common Instance Reference Module. More...
virtual IODSOPCommonModule & | getIODSOPCommonModule ()
| Get SOP Common Module. More...
virtual OFCondition | getImageType (OFString &value, const long pos)
| Get Image Type. More...
virtual OFCondition | getAcquisitionNumber (Sint32 &value, const unsigned long pos)
| Get Acquisition Number. More...
virtual OFCondition | getAcquisitionNumber (OFString &value, const long pos)
| Get Acquisition Number. More...
virtual OFCondition | getAcquisitionDateTime (OFString &value, const long pos)
| Get Acquisition DateTime. More...
virtual OFCondition | getAcquisitionDuration (Float64 &value, const unsigned long pos)
| Get Acquisition Duration. More...
virtual OFCondition | getAcquisitionDuration (OFString &value, const long pos)
| Get Acquisition Duration. More...
virtual OFCondition | getContentQualification (OFString &value, const long pos)
| Get Content Qualification. More...
virtual OFCondition | getImageComments (OFString &value, const long pos)
| Get Image Comments. More...
virtual OFCondition | getBurnedInAnnotation (OFString &value, const long pos)
| Get Burned In Annotation (if filled in correctly by creator, this should always be "NO"). More...
virtual OFCondition | getRecognizableVisualFeatures (OFString &value, const long pos)
| Get Recognizable Visual Features. More...
virtual OFCondition | getLossyImageCompression (OFString &value, const long pos)
| Get Lossy Image Compression. More...
virtual OFCondition | getLossyImageCompressionRatio (Float64 &value, const unsigned long pos)
| Get Lossy Image Compression Ratio. More...
virtual OFCondition | getLossyImageCompressionRatio (OFString &value, const long pos)
| Get Lossy Image Compression Ratio. More...
virtual OFCondition | getLossyImageCompressionMethod (OFString &value, const long pos)
| Get Lossy Image Compression Method. More...
virtual OFCondition | getPresentationLUTShape (OFString &value, const long pos)
| Get Presentation LUT Shape. More...
virtual OFCondition | getMultiEnergyCTAcquisition (OFString &value, const long pos)
| Get Multi-Energy CT Acquisition. More...
virtual OFCondition | getPixelPresentation (OFString &value, const long pos)
| Get Pixel Presentation. More...
virtual OFCondition | getVolumetricProperties (OFString &value, const long pos)
| Get Volumetric Properties. More...
virtual OFCondition | getVolumeBasedCalculationTechnique (OFString &value, const long pos)
| Get Volume Based Calculation Technique. More...
virtual OFCondition | getIsocenterPosition (OFString &value, const long pos)
| Get Isocenter Position. More...
virtual OFCondition | getIsocenterPosition (OFVector< Float64 > &values)
| Get Isocenter Position. More...
virtual OFCondition | getRows (Uint16 &rows)
| Get number of rows. More...
virtual OFCondition | getColumns (Uint16 &cols)
| Get number of cols. More...
virtual OFCondition | setLossyImageCompression (const OFBool isLossy, const OFString &ratios="", const OFString &methods="", const OFBool check=OFTrue)
| Set lossy compression flag of the image to "00" or "01" If set to "01", ratios and methods have to be provided, too. More...
virtual OFCondition | setISOCenterPosition (const OFVector< Float64 > &values, const OFBool check=OFTrue)
| Set Isocenter Position. More...
virtual OFCondition | setISOCenterPosition (const OFString &value, const OFBool check=OFTrue)
| Set Isocenter Position. More...
virtual OFCondition | setMultiEnergyCTAcquisition (const OFString &value, const OFBool check=OFTrue)
| Set Multi-Energy CT Acquisition. More...
virtual OFCondition | setPixelPresentation (const EctTypes::E_PixelPresentation value, const OFBool check=OFTrue)
| Set Pixel Presentation. More...
virtual OFCondition | setVolumetricProperties (const EctTypes::E_VolumetricProperties value, const OFBool check=OFTrue)
| Set Volumetric Properties. More...
virtual OFCondition | setVolumeBasedCalculationTechnique (const OFString &value, const OFBool check=OFTrue)
| Set Volume Based Calculation Technique. More...
Public Member Functions inherited from DcmIODImage< IODImagePixelModule< Uint16 >, IODImagePixelModule< Sint16 > >
| DcmIODImage ()
| Constructor, creates new DcmIODImage instance with integer-based pixel data.
| DcmIODImage (OFin_place_type_t(ImagePixel))
| Constructor, constructs new DcmIODImage instance with integer, float or double based Image Pixel Module (i. More...
virtual | ~DcmIODImage ()
| Virtual Destructor.
IODGeneralImageModule & | getGeneralImage ()
| Get General Image Module. More...
IODImagePixelModuleType & | getImagePixel ()
| Get Image Pixel Module (variant) More...
virtual void | clearData ()
| Clear (removes) all attributes handled by the modules of this IOD. More...
Public Member Functions inherited from DcmIODCommon
| DcmIODCommon ()
| Constructor.
| DcmIODCommon (const DcmIODCommon &rhs)
| Copy Constructor. More...
OFshared_ptr< IODRules > | getRules ()
| Get rules handled by this IOD. More...
OFshared_ptr< DcmItem > | getData ()
| Get item managed by this IOD. More...
IODPatientModule & | getPatient ()
| Get Patient Module. More...
IODPatientStudyModule & | getPatientStudy ()
| Get Patient Study Module. More...
IODGeneralStudyModule & | getStudy ()
| Get General Study Module. More...
IODGeneralEquipmentModule & | getEquipment ()
| Get General Equipment Module. More...
IODGeneralSeriesModule & | getSeries ()
| Get Series Module. More...
IODFoRModule & | getFrameOfReference ()
| Get Frame of Reference Module. More...
IODSOPCommonModule & | getSOPCommon ()
| Get SOP Common Module. More...
IODCommonInstanceReferenceModule & | getCommonInstanceReference ()
| Get Common Instance Reference Module. More...
virtual | ~DcmIODCommon ()
| Destructor.
virtual void | createNewStudy (const OFBool clearEquipment=OFTrue)
| Create new study. More...
virtual void | createNewSeries (const OFBool clearFoR=OFTrue)
| Create a new series. More...
virtual void | createNewSOPInstance ()
| Create a new SOP instance. More...
virtual void | ensureInstanceUIDs (const OFBool correctInvalid=OFFalse)
| Make sure that the IOD contains a SOP Instance, Series Instance and Study Instance UID. More...
virtual OFCondition | importHierarchy (DcmItem &dataset, const OFBool readPatient, const OFBool readStudy, const OFBool readFoR=OFFalse, const OFBool readSeries=OFFalse, const OFBool takeOverCharset=OFTrue)
| Import common module attributes from dataset but only read Patient, Study, Series and/or Frame of Reference level portions. More...
virtual OFCondition | importHierarchy (const OFString &filename, const OFBool readPatient, const OFBool readStudy, const OFBool readFoR=OFFalse, const OFBool readSeries=OFFalse, const OFBool takeOverCharset=OFTrue)
| CAUTION: Parameter order (readFoR and readSeries) changed compared to the old import() function. More...
virtual OFBool | getValueCheckOnWrite () const
| Get whether attribute value errors will be handled as errors on writing. More...

## Static Public Member Functions
static OFCondition | loadFile (const OFString &filename, EctEnhancedCT *&ct)
| Static method to load a Enhanced CT object from a file. More...
static OFCondition | loadDataset (DcmDataset &dataset, EctEnhancedCT *&ct)
| Static method to load a Enhanced CT object from a dataset object. More...
static OFCondition | loadConcatenation (ConcatenationLoader &cl, const OFString &concatenationUID, EctEnhancedCT *&ct)
| Static method to load a concatenation of a DICOM Enhanced CT instance into a EctEnhancedCT object. More...
static OFCondition | create (EctEnhancedCT *&ct, const Uint16 rows, const Uint16 columns, const OFBool signedPixelData, const EctTypes::E_ImageType1 imageType1, const OFString &imageType3, const OFString &imageType4, const OFString &instanceNumber, const EctTypes::E_ContentQualification contentQualification, const EctTypes::E_PixelPresentation pixelPresentation, const EctTypes::E_VolumetricProperties volumetricProperties, const OFString &volumeBasedCalculationTechnique, const IODEnhGeneralEquipmentModule::EquipmentInfo &equipmentInfo, const OFString &acquisitionDateTime="", const Float64 &acquisitionDuration=-1.0)
| Factory method to create an Enhanced CT object from the minimal set of information required. More...

## Protected Member Functions
template<typename ImagePixel >
| EctEnhancedCT (OFin_place_type_t(ImagePixel))
| Protected default constructor. More...
virtual OFCondition | read (DcmItem &dataset)
| Overwrites and publicly hides DcmIODImage::read() More...
virtual OFCondition | write (DcmItem &dataset)
| Overwrites and publicly hides DcmIODImage::write() More...
virtual OFCondition | writeGeneric (DcmItem &dataset)
| Writes pixel data to item. More...
virtual OFCondition | readGeneric (DcmItem &dataset)
| Read Enhanced CT's generic (not directly pixel-data related) attributes from DICOM dataset. More...
virtual IODGeneralImageModule & | getGeneralImage ()
| General Image Module is not allowed in Enhanced CT, remove from public interface. More...

## Static Private Member Functions
static OFCondition | decompress (DcmDataset &dset)
| Decompress the given dataset. More...

## Private Attributes
IODSynchronizationModule | m_SynchronizationModule
| Synchronization Module.
OFBool | m_SynchronizationModuleEnabled
| Denote whether Synchronization Module is enabled (OFTrue) or ignored (OFFalse) on writing and checking.
IODEnhGeneralEquipmentModule | m_EnhancedGeneralEquipmentModule
| IODEnhancedEquipmentModule.
IODMultiFrameFGModule | m_FG
| Multi-frame Functional Groups module.
IODMultiframeDimensionModule | m_DimensionModule
| Multi-frame Dimension Module.
IODAcquisitionContextModule | m_AcquisitionContextModule
| Acquisition Context Module.
IODCommonInstanceReferenceModule | m_CommonInstanceReferenceModule
| Common Instance Reference Module.
OFVector< DcmIODTypes::FrameBase * > | m_Frames
| Binary frame data.
FGInterface | m_FGInterface
| Multi-frame Functional Groups high level interface.
DcmCodeString | m_ImageType
| Image Type: (CS, VM 4, Type 1)
DcmIntegerString | m_InstanceNumber
| Instance Number: (IS, VM 1, Type 1)
DcmCodeString | m_MultiEnergyCTAcquisition
| Multi-Energy CT Acquisition: (CS VM 1, Type 3)
DcmCodeString | m_PixelPresentation
| Pixel Presentation: (CS, VM 1, Type 1)
DcmCodeString | m_VolumetricProperties
| Volumetric Properties: (CS, VM 1, Type 1)
DcmCodeString | m_VolumeBasedCalculationTechnique
| Volume Based Calculation Technique: (CS, VM 1, Type 1)
DcmIntegerString | m_AcquisitionNumber
| Acquisition Number: (IS, VM 1, Type 3)
DcmDateTime | m_AcquisitionDateTime
| Acquisition DateTime: (DT, VM 1, Type 1C)
DcmFloatingPointDouble | m_AcquisitionDuration
| Acquisition Duration: (FD, VM 1, Type 1C)
DcmCodeString | m_ContentQualification
| Content Qualification: (CS, VM 1, Type 1C)
DcmLongText | m_ImageComments
| Image Comments: (LT, VM 1, Type 3)
DcmCodeString | m_BurnedInAnnotation
| Burned In Annotation: (CS, VM 1, Type 1C)
DcmCodeString | m_RecognizableVisualFeatures
| Recognizable Visual Features: (CS, VM 1, Type 3)
DcmCodeString | m_LossyImageCompression
| Lossy Image Compression: (CS, VM 1, Type 1C)
DcmDecimalString | m_LossyImageCompressionRatio
| Lossy Image Compression Ratio: (DS, VM 1, Type 1C)
DcmCodeString | m_LossyImageCompressionMethod
| Lossy Image Compression Method: (CS, VM 1, Type 1C)
DcmCodeString | m_PresentationLUTShape
| Presentation LUT Shape: (CS, VM 1, Type 1)
DcmDecimalString | m_IsoCenterPosition
| Isocenter Position: (DS, VM 3, Type 3)

## Detailed Description

Class representing an object of the "Enhanced CT SOP Class".

Supported Modules:

- Patient (via iodimage.h)
- Patient Study (via iodimage.h)
- General Study (via iodimage.h)
- General Series (via iodimage.h)
- Enhanced CT Series (via this class)
- Frame of Reference (via iodimage.h)
- Synchronization (via modsynchronization.h)
- General Equipment (via iodimage.h)
- Enhanced General Equipment (via modenhequipment.h)
- Image Pixel (via this class)
- Multi-frame Functional Groups (via modmultiframefg.h)
- Multi-frame Dimension (via modmultiframedimension.h)
- Acquisition Context (via modacquisitioncontext.h)
- Enhanced CT (via mod_enhanced_ct.h)
- SOP Common (via iodimage.h)
- Common Instance Reference (via iodimage.h)

Modules that are not supported:

- Enhanced Contrast/Bolus
- Cardiac Synchronization
- Respiratory Synchronization
- Supplemental Palette Color Lookup Table
- Device
- Specimen
- Enhanced Multi-energy CT Acquisition
- ICC Profile
- Frame Extraction

## Constructor & Destructor Documentation

## ◆ EctEnhancedCT()

template<typename ImagePixel >

EctEnhancedCT::EctEnhancedCT | ( | OFin_place_type_t(ImagePixel) |  | ) |
| protected

Protected default constructor.

Library users should the factory create..() method in order to create an object from scratch

## Member Function Documentation

## ◆ addForAllFrames()

virtual OFCondition EctEnhancedCT::addForAllFrames | ( | const FGBase & | group | ) |
| virtual

Add a functional group for all frames.

Parameters

  group | The group to be added as shared functional group. The

Returns
  EC_Normal if adding was successful, error otherwise

## ◆ check()

virtual OFBool EctEnhancedCT::check | ( | const OFBool | checkFGStructure = `OFTrue` | ) |
| virtual

Perform some basic checking.

This method is also invoked when writing the object to a DICOM dataset or file.

Parameters

  checkFGStructure | If OFTrue (default), structure of functional groups is checked, too.

Returns
  OFTrue, if no errors were found, OFFalse otherwise.

## ◆ create()

static OFCondition EctEnhancedCT::create | ( | EctEnhancedCT *& | ct,
|  | const Uint16 | rows,
|  | const Uint16 | columns,
|  | const OFBool | signedPixelData,
|  | const EctTypes::E_ImageType1 | imageType1,
|  | const OFString & | imageType3,
|  | const OFString & | imageType4,
|  | const OFString & | instanceNumber,
|  | const EctTypes::E_ContentQualification | contentQualification,
|  | const EctTypes::E_PixelPresentation | pixelPresentation,
|  | const EctTypes::E_VolumetricProperties | volumetricProperties,
|  | const OFString & | volumeBasedCalculationTechnique,
|  | const IODEnhGeneralEquipmentModule::EquipmentInfo & | equipmentInfo,
|  | const OFString & | acquisitionDateTime = `""`,
|  | const Float64 & | acquisitionDuration = `-1.0`
| ) |  |
| static

Factory method to create an Enhanced CT object from the minimal set of information required.

The actual frame data is added separately. The memory of the resulting Enhanced CT object has to be freed by the caller.

Parameters

  ct | The resulting Enhanced CT object if provided data is valid. Otherwise NULL is returned.
  rows | Number of rows of Enhanced CT frame data
  columns | Number of rows of Enhanced CT frame data
  signedPixelData | Denotes if pixel data is signed (OFTrue, Sint16) or unsigned (OFFalse, Uint16)
  imageType1 | First value for tag Image Type (0008,0008)
  imageType3 | Third Value for tag Image Type (0008,0008). See EctTypes::DT_ImageType3_... for Defined Terms.
  imageType4 | Fourth Value for tag Image Type (0008,0008). See EctTypes::DT_ImageType4_... for Defined Terms.
  instanceNumber | The value for tag Instance Number (0020,0013).
  contentQualification | The value for tag Content Qualification (0018,9004).
  pixelPresentation | The value for tag Pixel Presentation (0008,9205).
  volumetricProperties | The value for tag Volumetric Properties (0008,9206).
  volumeBasedCalculationTechnique | The value for tag Volume Based Calculation Technique (0008,9207).
  equipmentInfo | Equipment that is responsible for creating the EctEnhancedCT
  acquisitionDateTime | The date/time when the acquisition of data started. Required if value 1 of Image Type is is ORIGINAL or MIXED; may be present otherwise. If empty, value will not be set (default)
  acquisitionDuration | The time in seconds needed to complete the acquisition of data. Required if value 1 of Image Type is is ORIGINAL or MIXED; may be present otherwise. If negative, value will not be set (default)

Returns
  EC_Normal if creation was successful, error otherwise

## ◆ decompress()

static OFCondition EctEnhancedCT::decompress | ( | DcmDataset & | dset | ) |
| static private

Decompress the given dataset.

Parameters

  dset | The dataset to be decompressed

Returns
  EC_Normal if decompression worked (or dataset has already been decompressed), IOD_EC_CannotDecompress otherwise

## ◆ getAcquisitionDateTime()

virtual OFCondition EctEnhancedCT::getAcquisitionDateTime | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Acquisition DateTime.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getAcquisitionDuration() [1/2]

virtual OFCondition EctEnhancedCT::getAcquisitionDuration | ( | Float64 & | value,
|  | const unsigned long | pos
| ) |  |
| virtual

Get Acquisition Duration.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm)

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getAcquisitionDuration() [2/2]

virtual OFCondition EctEnhancedCT::getAcquisitionDuration | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Acquisition Duration.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getAcquisitionNumber() [1/2]

virtual OFCondition EctEnhancedCT::getAcquisitionNumber | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Acquisition Number.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getAcquisitionNumber() [2/2]

virtual OFCondition EctEnhancedCT::getAcquisitionNumber | ( | Sint32 & | value,
|  | const unsigned long | pos
| ) |  |
| virtual

Get Acquisition Number.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm)

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getBurnedInAnnotation()

virtual OFCondition EctEnhancedCT::getBurnedInAnnotation | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Burned In Annotation (if filled in correctly by creator, this should always be "NO").

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getCheckFGOnWrite()

virtual OFBool EctEnhancedCT::getCheckFGOnWrite | ( |  | ) |
| virtual

Returns whether functional group structure is checked before actual writing is performed in the write() method.

Returns
  OFTrue if checking is performed, OFFalse otherwise

## ◆ getColumns()

virtual OFCondition EctEnhancedCT::getColumns | ( | Uint16 & | cols | ) |
| virtual

Get number of cols.

Parameters

  cols | The number of columns (output)

Returns
  EC_Normal if getting was successful, error otherwise

## ◆ getConcatenationInfo()

virtual IODMultiFrameFGModule::ConcatenationInfo& EctEnhancedCT::getConcatenationInfo | ( |  | ) |
| virtual

Get reference t Concatenation information.

Returns
  Reference to ConcatenationInfo object

## ◆ getContentQualification()

virtual OFCondition EctEnhancedCT::getContentQualification | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Content Qualification.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getDimensions()

virtual IODMultiframeDimensionModule& EctEnhancedCT::getDimensions | ( |  | ) |
| virtual

Return reference to multi-fame dimension module.

Returns
  Reference to multi-frame dimension module

## ◆ getFrames()

virtual FramesType EctEnhancedCT::getFrames | ( |  | ) |
| virtual

Return Frames.

Returns
  All frames currently assigned to the object

## ◆ getFunctionalGroups()

virtual FGInterface& EctEnhancedCT::getFunctionalGroups | ( |  | ) |
| virtual

Get access to functional groups.

This is meant for reading data from functional groups that are not actively managed, i.e. made accessible by EctEnhancedCT. In rare cases, however, it makes sense to access it for writing too, e.g. in order to add Stacks; use with care!

Returns
  Reference to the functional groups

## ◆ getGeneralImage()

virtual IODGeneralImageModule& EctEnhancedCT::getGeneralImage | ( |  | ) |
| inline protected virtual

General Image Module is not allowed in Enhanced CT, remove from public interface.

Returns
  Reference to General Image Module

References DcmIODImage<>::getGeneralImage().

## ◆ getImageComments()

virtual OFCondition EctEnhancedCT::getImageComments | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Image Comments.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getImageType()

virtual OFCondition EctEnhancedCT::getImageType | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Image Type.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getIODAcquisitionContextModule()

virtual IODAcquisitionContextModule& EctEnhancedCT::getIODAcquisitionContextModule | ( |  | ) |
| virtual

Get Acquisition Context Module.

Returns
  a reference to the Acquisition Context Module

## ◆ getIODCommonInstanceReferenceModule()

virtual IODCommonInstanceReferenceModule& EctEnhancedCT::getIODCommonInstanceReferenceModule | ( |  | ) |
| virtual

Get Common Instance Reference Module.

Returns
  a reference to the Common Instance Reference Module

## ◆ getIODEnhGeneralEquipmentModule()

virtual IODEnhGeneralEquipmentModule& EctEnhancedCT::getIODEnhGeneralEquipmentModule | ( |  | ) |
| virtual

Get Enhanced General Equipment Module.

Returns
  a reference to the Enhanced General Equipment Module

## ◆ getIODFrameOfReferenceModule()

virtual IODFoRModule& EctEnhancedCT::getIODFrameOfReferenceModule | ( |  | ) |
| virtual

Get Frame of Reference Module.

Returns
  a reference to the IOD Frame of Reference Module

## ◆ getIODGeneralEquipmentModule()

virtual IODGeneralEquipmentModule& EctEnhancedCT::getIODGeneralEquipmentModule | ( |  | ) |
| virtual

Get General Equipment Module.

Returns
  a reference to the General Equipment Module

## ◆ getIODGeneralSeriesModule()

virtual IODGeneralSeriesModule& EctEnhancedCT::getIODGeneralSeriesModule | ( |  | ) |
| virtual

Get General Series Module.

Returns
  a reference to the IOD General Series Module

## ◆ getIODGeneralStudyModule()

virtual IODGeneralStudyModule& EctEnhancedCT::getIODGeneralStudyModule | ( |  | ) |
| virtual

Get General Study Module.

Returns
  a reference to the IOD General Study Module

## ◆ getIODMultiframeDimensionModule()

virtual IODMultiframeDimensionModule& EctEnhancedCT::getIODMultiframeDimensionModule | ( |  | ) |
| virtual

Get Multi-frame Dimension Module.

Returns
  a reference to the Multi-frame Dimension Module

## ◆ getIODMultiFrameFGModule()

virtual IODMultiFrameFGModule& EctEnhancedCT::getIODMultiFrameFGModule | ( |  | ) |
| virtual

Get Multi-frame Functional Groups Module.

Returns
  a reference to the Multi-frame Functional Groups Module

## ◆ getIODPatientModule()

virtual IODPatientModule& EctEnhancedCT::getIODPatientModule | ( |  | ) |
| virtual

Get Patient Module.

Returns
  a reference to the IOD Patient Module

## ◆ getIODPatientStudyModule()

virtual IODPatientStudyModule& EctEnhancedCT::getIODPatientStudyModule | ( |  | ) |
| virtual

Get Patient Study Module.

Returns
  a reference to the IOD Patient Study Module

## ◆ getIODSOPCommonModule()

virtual IODSOPCommonModule& EctEnhancedCT::getIODSOPCommonModule | ( |  | ) |
| virtual

Get SOP Common Module.

Returns
  a reference to the SOP Common Module

## ◆ getIODSynchronizationModule()

virtual IODSynchronizationModule& EctEnhancedCT::getIODSynchronizationModule | ( |  | ) |
| virtual

Get Synchronization Module.

Returns
  a reference to the IOD Frame of Reference Module

## ◆ getIODSynchronizationModuleEnabled()

virtual OFBool EctEnhancedCT::getIODSynchronizationModuleEnabled | ( |  | ) |
| virtual

Returns whether Synchronization Module is enabled for writing the Enhanced CT object.

Returns
  OFTrue, if Synchronization Module will be written, OFFalse otherwise.

## ◆ getIsocenterPosition() [1/2]

virtual OFCondition EctEnhancedCT::getIsocenterPosition | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Isocenter Position.

Parameters

  value | Reference to variable that should hold the result.
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getIsocenterPosition() [2/2]

virtual OFCondition EctEnhancedCT::getIsocenterPosition | ( | OFVector< Float64 > & | values | ) |
| virtual

Get Isocenter Position.

Parameters

  values | Reference to variable that should hold the result. Should hold 3 values if not empty and filled correctly by the creator of the Enhanced CT object.

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getLossyImageCompression()

virtual OFCondition EctEnhancedCT::getLossyImageCompression | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Lossy Image Compression.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getLossyImageCompressionMethod()

virtual OFCondition EctEnhancedCT::getLossyImageCompressionMethod | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Lossy Image Compression Method.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getLossyImageCompressionRatio() [1/2]

virtual OFCondition EctEnhancedCT::getLossyImageCompressionRatio | ( | Float64 & | value,
|  | const unsigned long | pos
| ) |  |
| virtual

Get Lossy Image Compression Ratio.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm)

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getLossyImageCompressionRatio() [2/2]

virtual OFCondition EctEnhancedCT::getLossyImageCompressionRatio | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Lossy Image Compression Ratio.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getMultiEnergyCTAcquisition()

virtual OFCondition EctEnhancedCT::getMultiEnergyCTAcquisition | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Multi-Energy CT Acquisition.

Parameters

  value | Reference to variable that should hold the result.
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getNumberOfFrames()

size_t EctEnhancedCT::getNumberOfFrames | ( |  | ) | const

Get number of frames, based on the number of items in the shared functional functional groups sequence (i.e. the attribute Number of Frames) is not trusted).

Returns
  The number of frames handled by this object

## ◆ getPixelPresentation()

virtual OFCondition EctEnhancedCT::getPixelPresentation | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Pixel Presentation.

Parameters

  value | Reference to variable that should hold the result.
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getPresentationLUTShape()

virtual OFCondition EctEnhancedCT::getPresentationLUTShape | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Presentation LUT Shape.

Parameters

  value | Reference to variable that should hold the result. Should always return the value "IDENTITY" if creator filled in the value correctly.
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getRecognizableVisualFeatures()

virtual OFCondition EctEnhancedCT::getRecognizableVisualFeatures | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Recognizable Visual Features.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getRows()

virtual OFCondition EctEnhancedCT::getRows | ( | Uint16 & | rows | ) |
| virtual

Get number of rows.

Parameters

  rows | The number of rows (output)

Returns
  EC_Normal if getting was successful, error otherwise

## ◆ getVolumeBasedCalculationTechnique()

virtual OFCondition EctEnhancedCT::getVolumeBasedCalculationTechnique | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Volume Based Calculation Technique.

Parameters

  value | Reference to variable that should hold the result.
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getVolumetricProperties()

virtual OFCondition EctEnhancedCT::getVolumetricProperties | ( | OFString & | value,
|  | const long | pos
| ) |  |
| virtual

Get Volumetric Properties.

Parameters

  value | Reference to variable that should hold the result.
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ importFromSourceImage() [1/2]

virtual OFCondition EctEnhancedCT::importFromSourceImage | ( | const OFString & | filename,
|  | const OFBool | takeOverCharset = `OFTrue`
| ) |  |
| virtual

Import Patient, Study, and Frame of Reference level information from the given item.

The method does only import Frame of Reference if Frame of Reference UID is found in the image (and no error is reported if not). The reason is that if the source images of the Enhanced CT do have an FoR, the Enhanced CT object must have the same one, so we must import it. If the images do not have an FoR, we must not try at all importing it. The current content of this object is not deleted before reading. If the log stream is set and valid the, the reason for any error might be obtained from the error/warning output.

Parameters

  filename | Reference to DICOM dataset from which the document should be read
  takeOverCharset | If OFTrue (default), Specific Character Set is taken over from imported dataset. If it's not present or empty (invalid), the attribute will not be present in this class either.

Returns
  EC_Normal if successful, an error code otherwise

## ◆ importFromSourceImage() [2/2]

virtual OFCondition EctEnhancedCT::importFromSourceImage | ( | DcmItem & | dataset,
|  | const OFBool | takeOverCharset = `OFTrue`
| ) |  |
| virtual

Import Patient, Study, and Frame of Reference level information from the given item.

The method does only import Frame of Reference if Frame of Reference (FoR) UID is found in the image (and no error is reported if not). The reason is that if the source images of the Enhanced CT do have an FoR, the Enhanced CT object must have the same one, so we must import it. If the images do not have an FoR, we must not try at all importing it. If the log stream is set and valid the, the reason for any error might be obtained from the error/warning output.

Parameters

  dataset | Reference to DICOM dataset from which the document should be read
  takeOverCharset | If OFTrue (default), Specific Character Set is taken over from imported dataset. If it's not present or empty (invalid), the attribute will not be present in this class either.

Returns
  EC_Normal if successful, an error code otherwise

## ◆ loadConcatenation()

static OFCondition EctEnhancedCT::loadConcatenation | ( | ConcatenationLoader & | cl,
|  | const OFString & | concatenationUID,
|  | EctEnhancedCT *& | ct
| ) |  |
| static

Static method to load a concatenation of a DICOM Enhanced CT instance into a EctEnhancedCT object.

Parameters

  cl | The ConcatenationLoader instance to be used. Must be configured so that load() can be called.
  concatenationUID | The Concatenation UID identifying the Concatenation within the Concatenations know to ConcatenationLoader cl.
  ct | The resulting Enhanced CT object, if loading was successful

Returns
  EC_Normal if loading was successful, error otherwise

## ◆ loadDataset()

static OFCondition EctEnhancedCT::loadDataset | ( | DcmDataset & | dataset,
|  | EctEnhancedCT *& | ct
| ) |  |
| static

Static method to load a Enhanced CT object from a dataset object.

The memory of the resulting Enhanced CT object has to be freed by the caller.

Parameters

  dataset | The dataset to read from
  ct | The resulting Enhanced CT object. NULL if dataset could not be read successfully.

Returns
  EC_Normal if reading was successful, error otherwise

## ◆ loadFile()

static OFCondition EctEnhancedCT::loadFile | ( | const OFString & | filename,
|  | EctEnhancedCT *& | ct
| ) |  |
| static

Static method to load a Enhanced CT object from a file.

The memory of the resulting Enhanced CT object has to be freed by the caller.

Parameters

  filename | The file to read from
  ct | The resulting Enhanced CT object. NULL if dataset could not be read successfully.

Returns
  EC_Normal if reading was successful, error otherwise

## ◆ read()

virtual OFCondition EctEnhancedCT::read | ( | DcmItem & | dataset | ) |
| protected virtual

Overwrites and publicly hides DcmIODImage::read()

Parameters

  dataset | The dataset to read from

Returns
  EC_Normal if reading succeeded, error otherwise

Reimplemented from DcmIODImage< IODImagePixelModule< Uint16 >, IODImagePixelModule< Sint16 > >.

## ◆ readGeneric()

virtual OFCondition EctEnhancedCT::readGeneric | ( | DcmItem & | dataset | ) |
| protected virtual

Read Enhanced CT's generic (not directly pixel-data related) attributes from DICOM dataset.

Parameters

  dataset | Reference to DICOM dataset to read from.

Returns
  EC_Normal if successful, an error code otherwise

## ◆ saveFile()

OFCondition EctEnhancedCT::saveFile | ( | const OFString & | filename,
|  | const E_TransferSyntax | writeXfer = `EXS_LittleEndianExplicit`
| ) |  |

Save current object to given filename.

Parameters

  filename | The file to write to
  writeXfer | The transfer syntax to be used

Returns
  EC_Normal if writing was successful, error otherwise.

## ◆ setCheckFGOnWrite()

virtual void EctEnhancedCT::setCheckFGOnWrite | ( | const OFBool | doCheck | ) |
| virtual

If enabled, functional group structure is checked before actual writing is performed in the write() method.

Checking might be time consuming on functional groups with many frames, though disabling might result in invalid functional group structures. Disabling should only be done if the user knows that the functional groups are valid, wants to to adapt the functional groups manually after calling write() or knows what he's doing otherwise.
Per default, checking is enabled.

Parameters

  doCheck | If OFTrue, checking will be performed. If OFFalse, no checks are performed.

## ◆ setIODSynchronizationModuleEnabled()

virtual void EctEnhancedCT::setIODSynchronizationModuleEnabled | ( | const OFBool | enabled | ) |
| virtual

Set whether Synchronization Module will be enabled when writing the Enhanced CT object.

Parameters

  enabled | If OFTrue, Synchronization Module will be written, otherwise not.

## ◆ setISOCenterPosition() [1/2]

virtual OFCondition EctEnhancedCT::setISOCenterPosition | ( | const OFString & | value,
|  | const OFBool | check = `OFTrue`
| ) |  |
| virtual

Set Isocenter Position.

Parameters

  value | Value that should be set
  check | If OFTrue, basic checks are performed whether the value is valid for this attribute

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setISOCenterPosition() [2/2]

virtual OFCondition EctEnhancedCT::setISOCenterPosition | ( | const OFVector< Float64 > & | values,
|  | const OFBool | check = `OFTrue`
| ) |  |
| virtual

Set Isocenter Position.

Parameters

  values | Value that should be set
  check | If OFTrue, basic checks are performed whether the values are valid for this attribute

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setLossyImageCompression()

virtual OFCondition EctEnhancedCT::setLossyImageCompression | ( | const OFBool | isLossy,
|  | const OFString & | ratios = `""`,
|  | const OFString & | methods = `""`,
|  | const OFBool | check = `OFTrue`
| ) |  |
| virtual

Set lossy compression flag of the image to "00" or "01" If set to "01", ratios and methods have to be provided, too.

Parameters

  isLossy | If OFTrue, Lossy Image Compression is set to "01", otherwise to "00".
  ratios | Compression ratios (separated by backslash) of the applied lossy compression steps. Only one value (and no backslash) if only one step was performed. The parameter is ignored if isLossy is OFFalse.
  methods | Methods (separated by backslash) of the applied lossy compression steps. Only one value (and no backslash) if only one step was performed. The parameter is ignored if isLossy is OFFalse.
  check | If OFTrue, the data provided is checked for validity

Returns
  EC_Normal if lossy compression info could be set, error code otherwise

## ◆ setMultiEnergyCTAcquisition()

virtual OFCondition EctEnhancedCT::setMultiEnergyCTAcquisition | ( | const OFString & | value,
|  | const OFBool | check = `OFTrue`
| ) |  |
| virtual

Set Multi-Energy CT Acquisition.

Parameters

  value | Value that should be set
  check | If OFTrue, basic checks are performed whether the value is valid for this attribute

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setPixelPresentation()

virtual OFCondition EctEnhancedCT::setPixelPresentation | ( | const EctTypes::E_PixelPresentation | value,
|  | const OFBool | check = `OFTrue`
| ) |  |
| virtual

Set Pixel Presentation.

Parameters

  value | Value that should be set
  check | Ignored in current implementation (enum value is always checked for validity).

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setValueCheckOnWrite()

virtual void EctEnhancedCT::setValueCheckOnWrite | ( | const OFBool | doCheck | ) |
| virtual

Set whether attribute values should be checked on writing, i.e.

if writing should fail if attribute values violate their VR, VM, character set or value length. A missing but required value is always considered an error, independent of this setting. If set to OFFalse, writing will always succeed, even if attribute value constraints are violated. A warning instead of an error will be printed to the logger.

Parameters

  doCheck | If OFTrue, attribute value errors are handled as errors on writing, if OFFalse any errors are ignored.

Reimplemented from DcmIODImage< IODImagePixelModule< Uint16 >, IODImagePixelModule< Sint16 > >.

## ◆ setVolumeBasedCalculationTechnique()

virtual OFCondition EctEnhancedCT::setVolumeBasedCalculationTechnique | ( | const OFString & | value,
|  | const OFBool | check = `OFTrue`
| ) |  |
| virtual

Set Volume Based Calculation Technique.

Parameters

  value | Value that should be set
  check | If OFTrue, basic checks are performed whether the value is valid for this attribute

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setVolumetricProperties()

virtual OFCondition EctEnhancedCT::setVolumetricProperties | ( | const EctTypes::E_VolumetricProperties | value,
|  | const OFBool | check = `OFTrue`
| ) |  |
| virtual

Set Volumetric Properties.

Parameters

  value | Value that should be set
  check | Ignored in current implementation (enum value is always checked for validity).

Returns
  EC_Normal, if value was set, error otherwise

## ◆ write()

virtual OFCondition EctEnhancedCT::write | ( | DcmItem & | dataset | ) |
| protected virtual

Overwrites and publicly hides DcmIODImage::write()

Parameters

  dataset | The dataset to write to

Returns
  EC_Normal if writing succeeded, error otherwise

Reimplemented from DcmIODImage< IODImagePixelModule< Uint16 >, IODImagePixelModule< Sint16 > >.

## ◆ writeConcatenation()

OFCondition EctEnhancedCT::writeConcatenation | ( | ConcatenationCreator & | cc | ) |

Write current object to a Concatenation.

Parameters

  cc | The Concatenation Creator object to be used. Must be configured so that writeNextInstance() is ready to be called.

Returns
  EC_Normal if writing was successful, error otherwise.

## ◆ writeDataset()

OFCondition EctEnhancedCT::writeDataset | ( | DcmItem & | dataset | ) |

Write current object to given item.

Parameters

  dataset | The item to write to

Returns
  EC_Normal if writing was successful, error otherwise.

## ◆ writeGeneric()

virtual OFCondition EctEnhancedCT::writeGeneric | ( | DcmItem & | dataset | ) |
| protected virtual

Writes pixel data to item.

Parameters

  dataset | The dataset to write to

Returns
  EC_Normal if writing succeeded, error otherwise

The documentation for this class was generated from the following file:

- dcmect/include/dcmtk/dcmect/enhanced_ct.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1